/*
 * Copyright
 *   2007 axYus - www.axyus.com
 *   2007 JP.Tessier - jean-philippe.tessier@axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.cp.xemelios.controls.models;

import org.xml.sax.SAXException;

import fr.gouv.finances.cp.utils.xml.marshal.InvalidXmlDefinition;
import fr.gouv.finances.cp.utils.xml.marshal.XmlAttributes;
import fr.gouv.finances.cp.utils.xml.marshal.XmlMarshallable;
import fr.gouv.finances.cp.utils.xml.marshal.XmlOutputter;

public class MessageModel implements XmlMarshallable {
    public static final transient String TAG = "message-echec";
    private StringBuffer content;
    
    public MessageModel(String tagName) {
        super();
        content = new StringBuffer();
    }
    public void addCharacterData(String cData) throws SAXException {
        content.append(cData);
    }
    public void addChild(XmlMarshallable child, String tagName)throws SAXException {}
    public XmlMarshallable getAttributes(XmlAttributes attributes)throws SAXException {
        return this;
    }
    public void marshall(XmlOutputter output) {
        output.startTag(TAG);
        String sContent = content.toString();
        boolean isCData = (sContent.indexOf('<')>=0 || sContent.indexOf('>')>=0);
        if(isCData) output.addCharacterData("<![CDATA[");
        output.addCharacterData(content.toString());
        if(isCData) output.addCharacterData("]]>");
        output.endTag(TAG);
    }
    public void validate() throws InvalidXmlDefinition {}
    public String getContent() { return content.toString(); }
    public String getHtmlContent() { return content.toString().replaceAll("<","&lt;").replaceAll(">","&gt;"); }
    @Override
    public MessageModel clone() {
        MessageModel mm = new MessageModel(TAG);
        mm.content = new StringBuffer(content.toString());
        return mm;
    }
}
